# load the libraries
options(stringsAsFactors = FALSE)
libraries <- "tidyverse,RColorBrewer,forestplot,reshape2"
libraries <- strsplit(libraries, ",")[[1]]
for (name in libraries) {
  suppressPackageStartupMessages(library(name, character.only=T, warn.conflicts=F, quietly=T, verbose=F))
}

SaveName <- "kal_genes" # assign a value between STAR, kal_tx and kal_genes
source("~/Dropbox/_Deconvolution_paper/Src/4.RNAseqObj.R") 
load("../enrichment/Reactordered.RData")


namenorm <- dir(pattern="tpm")[6]  

TPM <- read.table(paste0(namenorm, "/tpmFull_norm.txt"), sep="\t", header=T, row.names = 1,check.names = FALSE)
# TPMmedian1 <- t(aggregate(t(TPM), by=list(as.character(pheno$group)), median))
# colnames(TPMmedian1) <- TPMmedian1[1, ]
# TPMmedian <- TPMmedian1[-1, ]
# TPMmedian <-apply(TPMmedian,2,as.numeric)
# rownames(TPMmedian) <- rownames(TPM)
# dir.create(paste0(namenorm,"/enrichment"), showWarnings = FALSE)
# save(TPMmedian, file=paste0(namenorm,"/enrichment/TPMmedian.RData"))
load(paste0(namenorm,"/enrichment/TPMmedian.RData"))


# use TPMmedian[idxENS,colID] if you want alphabetically ordered or TPMmedian[idxENS,ord] for my order

ensID <- substr(rownames(TPMmedian),1,15)

vect <- ReactOrdered[1,]$genes[[1]]  
idx <- na.omit(match(vect,ensID))
idxENS <- rownames(TPMmedian[idx,])
p <- ggplot(melt(log2(TPMmedian[idxENS, pref_ord]+1)), aes(x=Var2, y=value,fill=Var2)) + geom_violin(color="white") + 
  scale_fill_manual(values=labelColors)+ theme_classic()+
  theme(text = element_text(size=6), axis.line = element_line(color="black",size=0.2),
        axis.text.x = element_text(angle = 90, hjust = 1, color = labelColors[pref_ord]))+ # legend.position='none', # add this to remove the legend
  guides(fill=guide_legend(ncol=1)) + xlab("Cell type") + ylab("HK scaled log2 TPM")
p
ggsave( paste0(namenorm,"/enrichment/fullPlot.pdf"), p,width = 4 ,height=12,units="in")#, scale = 3)

  fold =  paste0(namenorm,"/enrichment/Reactome")
  dir.create(fold, showWarnings = FALSE)
  for(i in 1:nrow(ReactOrdered)){
    idx <- na.omit(match(ReactOrdered[i,]$genes[[1]], ensID))
    if(length(idx) <= 3) next   # do not create plots for gene sets with less than 4 genes
    idxENS <- rownames(TPMmedian[idx,])
    p <- ggplot(melt(log2(TPMmedian[idxENS,pref_ord]+1)), aes(x=Var2, y=value,fill=Var2)) + geom_violin(color="white") + 
      scale_fill_manual(values=labelColors)+ geom_jitter(position=position_jitter(0.2), size=0.01)+
      theme_classic()+
      theme(text = element_text(size=6), axis.line = element_line(color="black",size=0.2),legend.position='none',
            axis.text.x = element_blank(), axis.title=element_blank(), axis.ticks.x=element_blank(),
            plot.title = element_text(color="black", size=8, face="bold",hjust = 0.5)   ) +
       scale_y_continuous(breaks=seq(0,20,2)) +   # so that it is consistent on the way it puts the numbers on the y-axis
      ggtitle(ReactOrdered[i,]$name) # ggtitle(paste0(ReactOrdered[i,]$name, " (", length(idx), ")"))
    p
    ggsave( paste0(fold, "/", gsub("/","-",ReactOrdered[i,]$name), ".pdf") , p,width = 4 ,height=1.8,units="in")#, scale = 3)
    print(i)
}

  