
setwd("~/Desktop/Work_temp/Deconvolution/RNA-seq")

source("~/Desktop/Work_temp/Source code/NGS pipelines/other scripts/counts_to_tpm.R")
# source("~/Desktop/Work_temp/Source code/clustering.R") # this should be called by .Rprofile

#for the server
# source("clustering.R")
# source("counts_to_tpm")

# load the data
if(SaveName == "STAR"){
  Method <- "STAR+featureCounts"
  load("STAR_DGE.RData")
  load("STAR_tpm.RData")
  counts <- STAR_DGE$counts  
  TPM <- STAR.tpm
  pheno <- STAR_DGE$samples
  features <- STAR_DGE$genes 
  len <- STAR_DGE$genes$length
}
# if(SaveName == "STAR_EL"){
#   Method <- "STAR+featureCounts(using_Effective_Lengths)"
#   load("STAR_DGE.RData")
#   load("STAR_tpm_EL.RData")
#   counts <- STAR_DGE$counts  
#   TPM <- STAR_TPM_EL$abundance
#   pheno <- STAR_DGE$samples
#   features <- STAR_DGE$genes 
#   len <- STAR_TPM_EL$length
# }
if(SaveName == "kal_tx"){
  Method <- "kallisto transcripts"
  load("kallisto_tx.RData")
  counts <- kallisto_tx$counts  
  TPM <- kallisto_tx$abundance
  pheno <- kallisto_tx$samples
  features <- kallisto_tx$genes 
  len <- kallisto_tx$length
}
if(SaveName == "kal_genes"){
  Method <- "kallisto genes"
  load("kallisto_gene.RData")
  counts <- kallisto_gene$counts  
  TPM <- kallisto_gene$abundance
  pheno <- kallisto_gene$samples
  features <- kallisto_gene$genes
  len <- kallisto_gene$length
}

namedir <- paste0("process_", SaveName)
dir.create(namedir, showWarnings = FALSE)
setwd(namedir)

#colors
library(RColorBrewer)
pref_ord <- c( "PBMCs", "Progenitors", "pDCs","Basophils LD", "Neutrophils LD","mDCs", "Monocytes C", 
          "Monocytes I", "Monocytes NC", "B Naive",  "B NSM", "B SM", "B Ex", "Plasmablasts",  
          "T CD4 Naive","Tfh", "Tregs", "Th1" ,  "Th1/Th17","Th17" ,"Th2" ,"T CD4 EMRA",
          "T CD8 Naive", "T CD8 CM" ,"T CD8 EM", "T CD8 EMRA" ,"MAIT", "T gd Vd2","T gd non-Vd2", "NK" )
labels <- factor(pref_ord, levels = pref_ord)
# colors <- brewer.pal(9, "Set1")
colors <- c("#67000D", "#E41A1C","#FC9272",
            "#00441B", "#33A02C" ,"#B2DF8A",
            "#8C510A","#FF7F00","#FFD723" ,
            "#08306B", "#377EB8","#9EBCDA", 
            "#3F007D","#984EA3", "#FCCDE5",
            "#252525","#999999" ,"#D9D9D9")
pal <- colorRampPalette(colors)
labelColors<- pal(nlevels(labels))
pie(rep(1, length(labelColors)), labels = sprintf("%d (%s)", seq_along(labelColors), labelColors), col =labelColors)
names(labelColors) <- pref_ord
dev.off()

# ord <- c("Basophils LD","Neutrophils LD","Monocytes C", "Monocytes I", "Monocytes NC","mDCs","pDCs",
#          "Tfh",  "Tregs", "Th1" ,  "Th1/Th17","Th17" ,"Th2" , "T CD4 Naive","NK","T CD4 EMRA","T gd Vd2",
#          "T gd non-Vd2" ,"MAIT", "T CD8 Naive", "T CD8 CM" ,"T CD8 EM", "T CD8 EMRA", "Progenitors" , "B Naive", 
#          "B NSM" , "B SM", "B Ex",  "Plasmablasts", "PBMCs")
# 
# ordTPM <- c("PBMCs","Progenitors","B Naive","B NSM","B Ex","B SM","Plasmablasts","T CD4 Naive","Tfh","Tregs","Th1","Th1/Th17",
#             "Th17","Th2","T CD4 EMRA", "T CD8 Naive","T CD8 CM","T CD8 EM","T CD8 EMRA","T gd Vd2","T gd non-Vd2","MAIT","NK",
#             "pDCs","mDCs", "Monocytes C", "Monocytes I", "Monocytes NC", "Neutrophils LD","Basophils LD") # you can also take the first column of the file: grouping_cell_types.txt
# ord <- c( "PBMCs", "Progenitors","B Naive",  "B NSM" , "B Ex", "B SM", "Plasmablasts",   # keep this order!
#           "T CD4 Naive","Tfh", "Tregs", "Th1" ,  "Th1/Th17","Th17" ,"Th2" ,"T CD4 EMRA",
#           "T CD8 Naive", "T CD8 CM" ,"T CD8 EM", "T CD8 EMRA", "T gd Vd2","T gd non-Vd2" ,"MAIT","NK", 
#           "pDCs","mDCs", "Monocytes C", "Monocytes I", "Monocytes NC", "Neutrophils LD", "Basophils LD")
# # you could create your own colors too!
# labelColors <- c(brewer.pal(9, "Set1"),brewer.pal(8, "Set2"),brewer.pal(8, "Dark2"), brewer.pal(12, "Paired")[c(1,3,9,10, 12)])
# names(labelColors) <- ord
