SaveName <- "kal_genes" # assign a value between STAR, kal_tx and kal_genes
source("~/Dropbox/_Deconvolution_paper/Src/4.RNAseqObj.R") 

libraries <- "dplyr,reshape2,ggplot2,RColorBrewer,limma,tidyr,ComplexHeatmap,circlize"
libraries <- strsplit(libraries, ",")[[1]]
for (name in libraries) {
  suppressPackageStartupMessages(library(name, character.only=T, warn.conflicts=F, quietly=T, verbose=F))
}


modules <- read.table("tpm/heatmapCOEXP/connectivity.txt")
TF <- read.delim("../genes_info/TF_AnimalTFDB Homo_sapiens_transcription_factors_gene_list.txt", check.names = F, row.names = 1)
TCF <- read.delim("../genes_info/TF_AnimalTFDB Homo_sapiens_transcription_co-factors_gene_list.txt", check.names = F, row.names = 1)
CR <- read.delim("../genes_info/TF_AnimalTFDB Homo_sapiens_chromatin_remodeling_factors_gene_list.txt", check.names = F, row.names = 1)
TFall <- c(rownames(TF),rownames(TCF)) #,rownames(CR)) 
TFall<- TFall[TFall %in% substr( features$gene_id, 1,15)]

modules$gene_name <- gsub("_ENS.*","",modules$gene_name)
modules$gene_id  <- substr( features$gene_id[match(modules$gene_name, features$gene_name)] , 1,15)

SELECTEDGENES <- TFall 
TFtot <- sum(SELECTEDGENES %in% modules$gene_id)
MODtot <- nrow(modules)
temp <- c()
for(i in unique(modules[,"mod"])){
  MODmod <-nrow(filter(modules, mod==i))
  
  MODtf <- sum(SELECTEDGENES %in% filter(modules, mod==i)$gene_id)
  MODnottf <- MODmod - MODtf
  RESTtf <- TFtot - MODtf
  RESTnottf <- MODtot - RESTtf
  
  contigency.matrix <- rbind( c(MODtf, MODnottf), c(RESTtf, RESTnottf) )
  fisher.test( contigency.matrix, alternative="greater")
  pval <- signif(fisher.test( contigency.matrix, alternative="greater")$p.value, 3) 
  if(pval <1) temp <- rbind(temp, c(i, pval))
}
temp
cbind(temp[,1], p.adjust(temp[,2]))
table(modules[na.omit(unique(match(TFall, modules$gene_id))),"mod"]) 
# the modules 1, 5 and 15 are enriched for transcription factors, although most
702/length(TFall) # put the number of TF in module 0

sum(table(modules[na.omit(unique(match(TFall, modules$gene_id))),"mod"]) )
(length(TFall) - 1220 ) / length(TFall) # put the total number of TFs in all modules

