SaveName <- "kal_genes" # assign a value between STAR, kal_tx and kal_genes
source("~/Dropbox/_Deconvolution_paper/Src/4.RNAseqObj.R") 
options(stringsAsFactors = FALSE)

# load the libraries
libraries <- "dplyr,reshape2,edgeR,ggplot2,RColorBrewer,VennDiagram"
libraries <- strsplit(libraries, ",")[[1]]
for (name in libraries) {
  suppressPackageStartupMessages(library(name, character.only=T, warn.conflicts=F, quietly=T, verbose=F))
}

iris <- read.delim("/Users/gianni/Desktop/Work_temp/Deconvolution/RNA-seq/genes_info/IRIS_table.txt", header = T)
bindea0 <- list(
    Bcells = c("MS4A1", "TCL1A", "MS4A1", "TCL1A", "HLA-DOB", "PNOC", "KIAA0125", "CD19", "CR2", "IGHG1", "FCRL2", "BLK", "IGHG1", "COCH", "OSBPL10",
                "IGHA1", "TNFRSF17", "ABCB4", "BLNK", "GLDC", "MEF2C", "MEF2C", "IGHM", "FAM30A", "SPIB", "BCL11A", "GNG7", "IGKC", "CD72", "MICAL3", 
                "BCL11A", "BACH2", "IGLC1", "CCR9", "QRSL1", "DTNB", "HLA-DQA1", "SCN3A", "QRSL1", "SLC15A2"),
    Tcells = c("PRKCQ", "CD3D", "CD3G", "CD28", "LCK", "TRAT1", "PRKCQ", "BCL11B", "CD2", "TRBC1", "TRA20", "ITM2A", "SH2D1A", "CD6", "CD96", "NCALD", "GIMAP5", "CD3E", "SKAP1") ,
                  
    Thelper = c("ICOS", "LRBA", "ITM2A", "FAM111A", "PHF10", "NUP107", "SEC24C", "NAP1L4", "BATF", "ASF1A", "FRYL", "FUSIP1", "TRA20", "RPA1", "UBE2L3", "ANP32B", "DDX50",
            "C13orf34", "PPP2R5C", "SLC25A12", "ATF2", "CD28", "GOLGA8A"), 
     TCM = c("CDC14A", "ATM", "USP9Y", "PCNX", "ATM", "FOXP1", "KLF12", "ST3GAL1", "INPP4B", "CASP8", "MLL", "PCM1", "RP11-74E24.2", "PHC3", "NFATC3", "LOC202134", "TIMM8A", 
              "ATF7IP", "REPS1", "PSPC1", "RPP38", "HNRPH1", "STX16", "CYLD", "SNRPN", "TRAF3IP3", "NEFL", "POLR2J2", "AQP3", "CG030", "PDXDC2", "CLUAP1", "DOCK9", "CYorf15B", 
              "CREBZF", "CEP68", "TXK", "SLC7A6", "FYB", "MAP3K1"),
     TEM = c("TRA20", "PRKY", "VIL2", "GDPD5", "CCR2", "MEFV", "C7orf54", "FLI1", "TBC1D5", "DDX17", "AKT3", "EWSR1", "TBCD", "CCR2", "NFATC4", "LTK"),
     Th1 = c("IFNG", "LTA", "APBB2", "DOK5", "IL12RB2", "APBB2", "APOD", "ZBTB32", "CD38", "CSF2", "CTLA4", "CD70", "DPP4", "EGFL6", "BST2", "DUSP5", "LRP8", "IL22", 
              "DGKI", "CCL4", "DPP4", "GGT1", "LRRN3", "SYNGR3", "ATP9A", "BTG3", "CMAH", "HBEGF", "SGCB"),
    Th2 = c("PMCH", "AHI1", "PTGIS", "AHI1", "CXCR6", "EVI5", "AHI1", "IL26", "MB", "NEIL3", "GSTA4", "PHEX", "SMAD2", "CENPF", "ANK1", "ADCY1", "AI582773", "LAIR2", 
            "SNRPD1", "CXCR6", "MICAL2", "DHFR", "SMAD2", "WDHD1", "BIRC5", "DHFR", "SLC39A14", "HELLS", "LIMA1", "CDC25C", "CDC7", "GATA3"),
    Tfh = c("CHI3L2", "CXCL13", "MYO7A", "CHGB", "MYO7A", "ICA1", "HEY1", "CDK5R1", "ST8SIA1", "PDCD1", "BLR1", "KIAA1324", "PVALB", "ICA1", "TSHR", "C18orf1", "HEY1", "TOX",
            "BLR1", "SLC7A10", "SMAD1", "POMT1", "PASK", "MKL2", "PTPN13", "PASK", "KCNK5", "C18orf1", "ZNF764", "MAF", "MYO6", "SIRPG", "THADA", "THADA", "MAGEH1", "B3GAT1", 
            "MAF", "SH3TC1", "HIST1H4K", "STK39"),
    Th17 = c("IL17A", "IL17A", "IL17RA", "RORC"),
    Tregs = c("FOXP3"), 
    CD8Tcells = c("CD8A", "CD8B", "PF4", "PRR5", "SF1", "LIME1", "DNAJB1", "ARHGAP8", "GZMM", "SLC16A7", "SFRS7", "APBA2", "C4orf15", "LEPROTL1", "ZFP36L2", "GADD45A", "ZFP36L2",
                  "MYST3", "ZEB1", "ZNF609", "C12orf47", "THUMPD1", "VAMP2", "ZNF91", "ZNF22", "TMC6", "DNAJB1", "FLT3LG", "CDKN2AIP", "TSC22D3", "TBCC", "RBM3", "ABT1", "C19orf6", 
                  "CAMLG", "PPP1R2", "AES", "KLF9", "PRF1"),
    Tgd = c("TRD", "TARP", "C1orf61", "TRGV9", "CD160", "TARP", "FEZ1"),
    cytotoxic = c("KLRD1", "KLRF1", "GNLY", "GNLY", "CTSW", "KLRB1", "KLRD1", "KLRK1", "NKG7", "GZMH", "KLRD1", "SIGIRR", "ZBTB16", "RUNX3", "APOL3", "RORA", "APBA2", 
                  "SIGIRR", "WHDC1L1", "DUSP2", "GZMA"),
    NK = c("LOC643313", "GAGE2", "ZNF747", "XCL1", "XCL2", "AF107846", "SLC30A5", "NM_014114", "MCM3AP", "TBXA2R", "CDC5L", "LOC730096", "FUT5", "FGF18", "MRC2", 
          "RP5-886K2.1", "SPN", "PSMD4", "PRX", "FZR1", "ZNF205", "AL080130", "ZNF528", "MAPRE3", "BCL2", "NM_017616", "ARL6IP2", 
          "FZR1", "PDLIM4", "NM_014274", "LDB3", "ADARB1", "SMEK1", "TCTN2", "TINAGL1", "IGFBP5", "ALDH1B1", "NCR1"),
    NKCD56dim = c("KIR3DL2", "SPON2", "KIR2DL3", "GZMB", "KIR3DS1", "KIR3DL1", "FLJ20699", "TMEPAI","IL21R", "KIR3DL3",
                  "KIR2DS5", "KIR2DS2", "GTF3C1", "KIR2DS1", "EDG8"),
    NKCD56br = c("DUSP4", "RRAD", "XCL1", "PLA2G6", "NIBP", "FOXJ1", "MARCH6", "PLA2G6", "MADD", "BG255923", "MPPED1", "MUC3B"),
    DC = c("CD209", "CCL17", "HSD11B1", "CCL13", "CCL22", "PPFIBP2", "NPR1"),
    iDC = c("CD1B", "VASH1", "F13A1", "CD1E", "MMP12", "FABP4", "CLEC10A", "SYT17", "MS4A6A", "CTNS", "GUCA1A", "CARD9", "CD1E", 
          "ABCG2", "CD1A", "PPARG", "RAP1GAP", "SLC7A8", "GSTT1", "NM_021941", "FZD2", "CSF1R", "HS3ST2", "CH25H", "LMAN2L", 
          "SLC26A6", "BLVRB", "NUDT9", "PREP", "TM7SF4", "TACSTD2", "CD1C"),
    aDC = c("CCL1", "EBI3", "INDO", "LAMP3", "OAS3"),
    pDC = c("IL3RA")
)
bindea <- melt(bindea0)
# My data
namenorm <- dir(pattern="tpm")[6]
TPM <- read.table(paste0(namenorm, "/tpm_norm.txt"), sep="\t", header=T, row.names = 1,check.names = FALSE)
TPM <- TPM[!duplicated(features[rownames(TPM),]$gene_name),]
DEFC <- read.table(paste0(namenorm, "/DEdecFC.txt"), sep="\t", header=T, row.names = 1,check.names = FALSE)
DEFC <- DEFC[rownames(TPM),]
DEFDR <- read.table(paste0(namenorm, "/DEdecFDR.txt"), sep="\t", header=T, row.names = 1,check.names = FALSE)
DEFDR <- DEFDR[rownames(TPM),]
TPM_gene_names <- TPM
rownames(TPM_gene_names) <- DEFC$gene_name

dir.create(paste0(namenorm,"/vennDiagram"), showWarnings = FALSE)
# setwd("heatmapDE")

GRdf <- cbind.data.frame(as.character(pheno$group), pheno[,grep("group[0-9]", colnames(pheno))], stringsAsFactors =F)
GRvec <- unique(unlist(GRdf))
GR1 <- colnames(DEFC)[which(colnames(DEFC) %in% GRvec)]

DEFDR1 <- DEFDR[,c("gene_name", GR1)]
DEFC1 <- DEFC[,c("gene_name", GR1)]
DEFDRmelt <- melt(DEFDR1, id.vars = c("gene_name"))
DEFCmelt <- melt(DEFC1, id.vars = c("gene_name"))
FC1 <- DEFCmelt  %>% filter(value > 2 ) %>% arrange(desc(value)) # using the fold change of 2 seems to improve the results respect to smaller fold changes
FDR1 <- DEFDRmelt  %>% filter(value > 0 & value < 0.05 ) %>% arrange(value) # if you change the threshowld with 0.2 you get worse results
#FC1 <- FC1[!duplicated(FC1$gene_name),]  # This is to remove duplicate specific genes. In this case I don't want it
combFC1 <- paste(FC1$gene_name, FC1$variable)
combFDR1 <- paste(FDR1$gene_name, FDR1$variable)
FDR1 <- FDR1[combFDR1 %in% combFC1, ]

#Remove genes not in my data
iris2<- iris[iris$Name %in% features$gene_name,]
bindea2 <- bindea[bindea$value %in% features$gene_name,]

#########################################
###### Now create the venn diagrams #####

tcells <- list(`This work` = subset(FDR1, variable=="T cells")[,1],
               `Abbas et al. 2005` = unique(subset(iris2, Cell.Specificity == "TCell")[,5]),
               `Bindea et al. 2013` = unique(bindea2[bindea2$L1 %in% c("Tcells", "Thelper", "TCM", "TEM", "Th1", "Th2", 
                                                         "Tfh", "Th17", "Tregs", "CD8Tcells", "Tgd", "cytotoxic"), 1]))
VDtcells <- venn.diagram(tcells, filename = NULL, main = "T cells",
                         cex = 1,lwd=0.5,main.cex = 1.3,
                         fill = c("darkolivegreen1",  "aquamarine", "darkgoldenrod1"))
plot.new()
grid.draw(VDtcells)
# par(mar=c(5,5,5,5))
pdf(file=paste0(namenorm,"/vennDiagram/Tcells.pdf"), width = 3, height = 3,
    pointsize = 7)
grid.draw(VDtcells)
dev.off()


bcells <- list(`This work` = subset(FDR1, variable=="B cells")[,1],
               `Abbas et al. 2005` = unique(subset(iris2, Cell.Specificity == "BCell")[,5]),
               `Bindea et al. 2013` = unique(bindea2[bindea2$L1 %in% c("Bcells"), 1]))
VDbcells <- venn.diagram(bcells, filename = NULL, main = "B cells",
                         cex = 1,lwd=0.5,main.cex = 1.3,
                         fill = c("darkolivegreen1",  "aquamarine", "darkgoldenrod1"))
plot.new()
grid.draw(VDbcells)
# par(mar=c(5,5,5,5))
pdf(file=paste0(namenorm,"/vennDiagram/Bcells.pdf"), width = 3, height = 3,
    pointsize = 7)
grid.draw(VDbcells)
dev.off()


NKcells <- list(`This work` = subset(FDR1, variable=="NK")[,1],
               `Abbas et al. 2005` = unique(subset(iris2, Cell.Specificity == "NKCell")[,5]),
               `Bindea et al. 2013` = unique(bindea2[bindea2$L1 %in% c("NK", "NKCD56dim", "NKCD56br"), 1]))
VDNKcells <- venn.diagram(NKcells, filename = NULL, main = "NK cells",
                          cex = 1,lwd=0.5,main.cex = 1.3,
                          fill = c("darkolivegreen1",  "aquamarine", "darkgoldenrod1"))
plot.new()
grid.draw(VDNKcells)
# par(mar=c(5,5,5,5))
pdf(file=paste0(namenorm,"/vennDiagram/NKcells.pdf"), width = 3, height = 3,
    pointsize = 7)
grid.draw(VDNKcells)
dev.off()




DCcells <- list(`This work` = subset(FDR1, variable=="DCs")[,1],
                `Abbas et al. 2005` = unique(subset(iris2, Cell.Specificity == "DendriticCell")[,5]),
                `Bindea et al. 2013` = unique(bindea2[bindea2$L1 %in% c("DC", "iDC", "aDC", "pDC"), 1]))
VDDCcells <- venn.diagram(DCcells, filename = NULL, main = "Dendritic cells",
                          cex = 1,lwd=0.5,main.cex = 1.3,
                          fill = c("darkolivegreen1",  "aquamarine", "darkgoldenrod1"))
plot.new()
grid.draw(VDDCcells)
# par(mar=c(5,5,5,5))
pdf(file=paste0(namenorm,"/vennDiagram/DCcells.pdf"), width = 3, height = 3,
    pointsize = 7)
grid.draw(VDDCcells)
dev.off()
