SaveName <- "kal_genes" # assign a value between STAR, kal_tx and kal_genes
source("~/Dropbox/_Deconvolution_paper/Src/4.RNAseqObj.R") 
source("~/Desktop/Work_temp/Source code/deconvolution/CIBERSORT.R")
source("~/Desktop/Work_temp/Source code/deconvolution/LLS.R")
source("~/Desktop/Work_temp/Source code/deconvolution/Qprog.R")
# evaluate performance of Qprogramming, lls, and cibersort using different matrices. Compare to the real proportion. try also DSA
libraries <- "dplyr,reshape2,edgeR,ggplot2,RColorBrewer,e1071,preprocessCore,epiR,MASS,DeconRNASeq,RColorBrewer"
libraries <- strsplit(libraries, ",")[[1]]
for (name in libraries) {
  suppressPackageStartupMessages(library(name, character.only=T, warn.conflicts=F, quietly=T, verbose=F))
}
rmse <- function(v1, v2) sqrt((mean((v1 - v2)^2)))
load("datFDRfilt.RData") # datfilt and datNOfilt
load("MedianGeneName.RData") # MEDg
load("TPMPBMC.RData")  # TPMPBMC
load("flowtemp.RData")  # flowtemp
load("optimizationSigMat.RData") # optRes
MEDgNORM <- sweep(MEDg[,names(optRes)] , MARGIN=2, optRes, `*`)
#MEDgNORM2 <- t(aggregate(t(MEDgNORM), by= list(names(GR0)), median))
#colnames(MEDgNORM2) <- MEDgNORM2[1,]
#MEDgNORM3 <- MEDgNORM2[-1,]
#class(MEDgNORM3) <- "numeric"

for(a in 1:2){
  if( a ==1){
    dat <- datNOfilt %>% group_by(variable) %>% slice(1:100) # without filtering
  }else{
    dat <- datfilt %>% group_by(variable) %>% slice(1:100) # with filtering
  }
  rmseLS <- c()
  rmseNNLS <- c()
  rmseQP <- c()
  rmseRLS <- c()
  rmseCIBERSORT <- c()
  for(i in 3:100){
    datgenes <- dat %>% group_by(variable) %>% slice(1:i) 
    genes <- unique(datgenes$gene_name)
    SigMat1 <- data.frame( MEDgNORM[genes ,colnames(flowtemp)] )
    MixMat1 <- TPMPBMC[rownames(SigMat1),]
    
    DecLS <- LLS(SigMat1, MixMat1, nneg = "none", rescale="none")*100
    DecNNLS <- LLS(SigMat1, MixMat1, nneg = "iterate", rescale="sumto1")*100
    DecQP <- (DeconRNASeq(MixMat1, SigMat1, use.scale=F)$out.all) * 100
    # DecQP <- qprog(SigMat1, MixMat1, exact=T)*100
    DecRLS <- t((apply(MixMat1, 2, function(x) coef(rlm( as.matrix(SigMat1), x )))) *100)
    # DecRLLS <-  apply(MixMat1, 2, function(x) coef(rlm(x ~ -1 + as.matrix(SigMat1))))
    DecCIB <- CIBERSORT(sig_matrix = SigMat1, mixture_file = MixMat1,QN=F)*100
    
    rmseLS <- c(rmseLS, sum(sapply(1:ncol(DecLS), function(x) rmse(DecLS[,x], flowtemp[,x]))))
    rmseNNLS <- c(rmseNNLS, sum(sapply(1:ncol(DecNNLS), function(x) rmse(DecNNLS[,x], flowtemp[,x]))))
    rmseQP <- c(rmseQP, sum(sapply(1:ncol(DecQP), function(x) rmse(DecQP[,x], flowtemp[,x]))))
    rmseRLS <- c(rmseRLS, sum(sapply(1:ncol(DecRLS), function(x) rmse(DecRLS[,x], flowtemp[,x]))))
    rmseCIBERSORT <- c(rmseCIBERSORT, sum(sapply(1:ncol(DecCIB), function(x) rmse(DecCIB[,x], flowtemp[,x]))))
    print(paste("filtering",a, "iteration",i))
  }
  if( a ==1){ rmseNOFILT <- cbind(rmseLS, rmseNNLS, rmseQP, rmseRLS, rmseCIBERSORT) }
  if( a ==2){ rmseFILT <- cbind(rmseLS, rmseNNLS, rmseQP, rmseRLS, rmseCIBERSORT)   }
  # 
}

datRMSE <- data.frame(rbind(rmseNOFILT,rmseFILT), filt=rep(c("without filtering", "with filtering"), each=nrow(rmseFILT)), Ngenes= c(3:100*ncol(flowtemp), 3:100*ncol(flowtemp)))
RMSEmelt <- melt(datRMSE, id.vars = c("filt", "Ngenes"))
RMSEmelt$variable <- gsub( "rmse", "", RMSEmelt$variable ) 
RMSEmelt$variable <- factor(RMSEmelt$variable, levels = c("LS", "NNLS", "QP","RLS","CIBERSORT") ) 
save(RMSEmelt, file="comparisonDEC.RData")
load("comparisonDEC.RData")

lineplot <- ggplot(data=RMSEmelt, aes(x=Ngenes, y=value, colour=variable)) +
  scale_colour_manual(values= brewer.pal(8,"Spectral")[c(3,7,4,8,1)] ) +  
  geom_line(aes(linetype=filt), size=1) +
  geom_point(size=0.5) +
 # expand_limits(y=0) +
  xlab("N. of genes in the signature matrix") + ylab("Total RMSE") +
  theme_bw() +
  theme(legend.title=element_blank())
lineplot
ggsave(paste0("deconOpt/linePlot.pdf"),lineplot, width = 10, height = 5)

