setwd("~/Desktop/Work_temp/Deconvolution/RNA-seq")
load("STAR_DGE.RData")
library(epiR)
library(ggplot2)
library(sleuth)
library(edgeR)
pheno <- STAR_DGE$samples
flowper <- read.table("../CellsPercentages.txt", sep ="\t", check.names = FALSE)/100
rmse <- function(v1, v2) sqrt((mean((v1 - v2)^2)))

indiv <- c("9JD4", "925L", "G4YW") # I removed "DZQV" as the percentages are not clear
celltypes <- sort(unique(pheno$group[(pheno$group != "PBMCs")]))

load("process_kal_genes/optimizationSigMat.RData")
normOPT <- apply(pheno, 1, function(x) optRes[unlist(x[x %in% names(optRes)][1])])
normOPT[is.na(normOPT)] <- 1
# idx<-which(!as.character(pheno$group) %in% c("CD8 TEMRA", "Plasmablasts", "Mono C", "pDCs", "NK", "Neutrophils", "Basophils", "MAIT", "gd non Vd2", "gd Vd2", "B Naive"))
# id0 <- which(apply(corFull,2, median) < 0.7)
# idx <- which( apply(pheno, 1, function(x) any(x %in% names(id0))) )
#normOPT[idx] <- pheno$pg_median[idx] *1.975153 


results <- c()
#for(a in dir(pattern="process")[1]){
  a <- dir(pattern="process")[1]
      tpm <- read.table(file.path(a,"tpm","tpm_norm.txt"), sep="\t", header = T, check.names = FALSE, row.names =1)
     # normF <- norm_factors(tpm)
      TMM <- calcNormFactors(tpm, reference=1)
      yTMM <- 1/(TMM)
    #  filter = apply(tpm[, which(!pheno$group %in% "PBMCs")], 1, function(x) length(x[x>500])>=3)
   #  filter = apply(tpm[, which(!pheno$group %in% "PBMCs")], 1, function(x) sum(x)>1000)
     # tpm <- tpm[filter,]
    
      for(norm in c("tpm","tpmTMM", "tpmRNAycell", "tpmRNAymed","tpmRNAyOPT")){
        if(norm == "tpm") tpm_norm <- tpm
        # if(norm == "tpmDESeq") tpm_norm <- sweep(tpm, MARGIN=2, normF, `/`)
        if(norm == "tpmTMM")  tpm_norm <- sweep(tpm, MARGIN=2, yTMM , `*`)
        if(norm == "tpmRNAycell")  tpm_norm <- sweep(tpm, MARGIN=2, pheno$pg_cell *1.975153 , `*`)
        if(norm == "tpmRNAymed")  tpm_norm <- sweep(tpm, MARGIN=2, pheno$pg_median *1.975153 , `*`)
        if(norm == "tpmRNAyOPT")  tpm_norm <- sweep(tpm, MARGIN=2, normOPT , `*`)
     # iqr <- apply(log2(tpm_norm+1), 1, IQR)
    for(i in indiv){
      phenoSub <- pheno[grep(i , pheno$Sample_Name ), ]
       expSub <- tpm_norm[, rownames(phenoSub)] 
      # expSub <- tpm_norm[names(which(iqr > 1.5)), rownames(phenoSub)] 
      # iqr_s <- sort(iqr, decreasing = T)
      # expSub <- fexp[names(iqr_s[1:(length(iqr)*0.1)]), rownames(phenoSub)] # uses top 5%
      idx <- na.omit(match(as.character(celltypes),as.character(phenoSub$group)))
      flowperSub <- as.numeric(flowper[i, as.character(celltypes[ celltypes %in% phenoSub$group[idx]])])
      realPBMC <-  (expSub[, which(phenoSub$group == "PBMCs")] * sum(flowperSub)) 
      
      assPBMC <-  rowSums( t(t(expSub[, idx]) * flowperSub) ) 
      ccc <- unlist(epi.ccc(assPBMC, realPBMC)$rho.c[1])
      #plot(assPBMC, realPBMC)
      ccc
       # cccP <- c()
       # for(p in 1:1000){
       #   assPBMC <- log2( rowSums( t(t(expSub[, sample(idx, replace = TRUE)]) * flowperSub) ) +1)
       #   cccP <- c(cccP, unlist(epi.ccc(assPBMC, realPBMC)$rho.c[1]))
       # }
       # pval <- mean(ccc < cccP) # this is the same of sum(ccc < cccP)/ 1000
      pval <- "999"
        
      cor <- cor(assPBMC, realPBMC)
      RMSE <- rmse(assPBMC, realPBMC)
      score <- (1/RMSE * cor)
      
      results <- rbind(results, c(a, norm, i,ccc, pval, cor, RMSE, score))
    }
      print(norm)
      }
  print(a)
# }
colnames(results) <- c("RNASeqMeth", "norm", "donor", "ccc", "P-val", "cor", "RMSE", "score")
# write.table(results, file= "ConstractionPBMCresults.txt", sep="\t", row.names=F)

###### PRODUCE BAR GRAPH
# results <- read.table("ConstractionPBMCresults.txt", sep="\t",header=T, stringsAsFactors = F)

## Preparing for pictures
proc <- results[,"RNASeqMeth"]
norm <- results[,"norm"]

# proc <- sub( "process_STAR", "STAR genes", proc)
 proc <- sub( "process_kal_genes", "kallisto genes", proc)
# proc <- sub( "process_kal_tx", "kallisto transcripts", proc)

 # if you want to change names use the following code
# norm <- sub( "tpm", "TPM", norm)
# norm <- sub( "TMM", " * 1/TMM", norm)
# norm <- sub( "RNAycell", " * 1.975 * cell yield", norm)
# norm <- sub( "RNAymed", " * 1.975 * median yield", norm)
# norm <- sub( "RNAyOPT", " * optimized yield", norm)

df <- data.frame(Processing = proc, Normalization = norm, rmse = as.numeric(results[,"RMSE"]), stringsAsFactors = F)

####### BARPLOT
myData <- aggregate(df$rmse,
        by = list(Processing = df$Processing, Normalization = df$Normalization ),
        FUN = function(x) c(mean = mean(x), sd = sd(x),  n = length(x)))
myData <- do.call(data.frame, myData)
myData$se <- myData$x.sd / sqrt(myData$x.n)
# myData$Processing <- relevel(myData$Processing, ref="STAR genes")

limits <- aes(ymax = myData$x.mean + myData$se, ymin = myData$x.mean - myData$se)
p <- ggplot(data = myData, aes(x = factor(Normalization, levels = as.character(myData$Normalization)[order(myData$x.mean+myData$x.sd, decreasing = T)] ), y = x.mean,
                               fill = Processing)) #+ coord_cartesian(ylim = c(0.6, 0.95)) 
p2 <- p + geom_bar(stat = "identity",
             position = position_dodge(0.9), fill="steelblue") +
  geom_errorbar(limits, position = position_dodge(0.9),
                width = 0.25)  + labs(x = "Normalization methods", y = "RMSE (real PBMCs vs assembled PBMCs)")  +
theme_bw() + theme(text = element_text(size=20), axis.text.x = element_text(angle = 90, hjust = 1, color= "black"), legend.position="none") + coord_flip()  # + scale_fill_discrete(name = "Features") 
p2

 ggsave("norm_methods.pdf", p2, width = 9, height = 5.5)
